fs = require 'fs'


HELP = 
    main: (argv)->
        if argv.length == 0
            console.log "Specify one of these actions :"
            for k,v of ACTIONS
                console.log " - ", k, " : ", v.DESCRIPTION
        else if argv.length == 1
            action = argv[0]
            if action of ACTIONS
                ACTIONS[action].help()
            else
                throw "Command does not exists : " + action
        else
            throw "Invalid command."


ACTIONS =
    serve: require "./tumbler-server.js"
    deploy:  require "./tumbler-deploy.js"
    help: HELP

main = (argv)->
    try
        if argv.length > 0
            action = argv[0]
            if ACTIONS[action]?
                return ACTIONS[action].main argv[1..]
            else
                throw '"' + action + '" is not an allowed action.'
        else
            throw "You need to specify an action."
    catch e
        console.log e
        console.log e.stack
        HELP.main []

exports.main = main

if require.main == module
    main process.argv[2..]
